#Copyright 2011, Chris Glasier 
#Visitor uses  on line universal assembler. 
#Needs to install Sketchup and this file.
#Needs to upload owner nameset.

#Only the nameset is saved

require 'sketchup.rb'

if (not file_loaded?("bridge.rb"))
 UI.menu("Plugins").add_item("Nameset" ){ NamesetBridge.start }
end


class NamesetBridgeObserver < Sketchup::ModelObserver
	attr_reader :opened
    def initialize
        @opened = 0
		model = Sketchup.active_model
    end
	def onPreSaveModel(model)
         @opening = 0
    end
end

module NamesetBridge
	def NamesetBridge.start
	
		Sketchup.send_action "selectSelectionTool:"
		
		def self.size
			@dlg.allow_actions_from_host("glasier.hk")
			@dlg.execute_script("doldExt('sketchup')")
			v = @dlg.get_element_value("trans")
			v = v.split(",")
			w = Integer(v[0])
			h = Integer(v[1])
			w = w + 2 * 2
			h = h + 22 + 2
			@dlg.set_size(w,h)
		end
				
		if(!@dlg)
			@dlg = UI::WebDialog.new("Nameset", false, "Nameset", 420, 154, 0, 0, false)
			@dlg.allow_actions_from_host("glasier.hk")
			@dlg.set_url("http://glasier.hk/machine.php")
			@dlg.show{
				size
			}
		end
		
		@dlg.add_action_callback("product") {|d, p|
			p p
			a = p.split(",")
			fn = a[0]+".skp"
   			x = Integer(a[1]).mm
			y = Integer(a[2]).mm
			z = Integer(a[3]).mm
   			point = Geom::Point3d.new x,y,z
   			transform = Geom::Transformation.new point
			model = Sketchup.active_model
			entities = model.active_entities
			url = 'http://glasier.hk/Product/' + fn
			p url
			#url = 'http://localhost/Product/' + fn
			#p url
			model.definitions.load_from_url url
			last_def_id = model.definitions.count - 1
			loaded_definition = model.definitions[last_def_id]
			instance = entities.add_instance loaded_definition, transform 
		}
    
	end # def NamesetBridge.start

end # module NamesetBridge

file_loaded("nameset.rb")
